<?php
namespace Controller;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource;
use Util\Instance\ServiceInstance;
use Util\Utilities;
class Objects {

    public function findObjectsBody(DTO\Request\Filter $request, DTO\Response $response)
    {
        $filters    = $request->getFilterCriteria()->getConditions();
        $objectName = Utilities::getValueInFilterDataSourceByName($filters, 'OBJECT_NAME', true);
        $objectType = Utilities::getValueInFilterDataSourceByName($filters, 'OBJECT_TYPE', true);
        $typeAbbreviation = Utilities::getValueInFilterDataSourceByName($filters, 'TYPE_ABBREVIATION', true);
        $object     = ServiceInstance::getObjects()->findObjectsBody($objectName, $objectType, $typeAbbreviation);
        $response->addDataSet(new DataSource\DataSet('objectBody', $object));
    }

    public function saveObjectObservation(DTO\Request\Dataset $request, DTO\Response $response)
    {
        try {
            $row = $request->getDataSet()->getRows()[0];
            $currentRow = $row["row"];
            $type = $row["type"];
            $object = $row["object_name"];
            $observation = $currentRow["OBSERVATION"];
            $result = ServiceInstance::getObjects()->saveObjectObservation($object, $type, $observation);
            $response->addDataSet(new DataSource\DataSet('objectObservations', [$result]));
        } catch(\Exception $ex) {
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }


}

