<?php
namespace Controller;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource;
use Util\Instance\ServiceInstance;
use Util\Utilities;
use Exception\CustomException;

class Repositorio {

    public function findRepositorio(DTO\Request\Filter $request, DTO\Response $response)
    {
        $page = $request->getFilterCriteria()->getPage();
        $pageSize = $request->getFilterCriteria()->getPageSize();
        $filters = $request->getFilterCriteria()->getConditions();
        $repositorio = ServiceInstance::getRepositorio()->findRepositorio($filters, $page, $pageSize);
        $response->addDataSet(new DataSource\DataSet('repositorio', $repositorio));
    }

    public function saveRepositorio(DTO\Request\DataSet $request, DTO\Response $response)
    {

        $repositorio = $request->getDataSet()->getRows()[0];
        $idativo = $repositorio["IDATIVO"];
        $nmrepositorio = $repositorio["NMREPOSITORIO"];
        $dsurlrepositorio = $repositorio["DSURLREPOSITORIO"];
        $diretorio = !empty($repositorio["DSDIRREPOSITORIO"]) ? $repositorio["DSDIRREPOSITORIO"] : null;
        try {
            $repositorioId = !empty($repositorio["ID"]) ? $repositorio["ID"] : null;
            $repositorioOperId = !empty($repositorio["D_ID"]) ? $repositorio["D_ID"] : null;
            $newRepositorio = ServiceInstance::getRepositorio()->saveRepositorio($repositorioId, $idativo, $nmrepositorio, $dsurlrepositorio, $diretorio, $repositorioOperId);
            $response->addDataSet(new DataSource\DataSet('repositorio', [$newRepositorio]));
        } catch(CustomException $e) {
            $response->setError(Utilities::getErrorObjectFromException($e));
        }
    }

    public function removeRepositorio(DTO\Request\DataSet $request, DTO\Response $response)
    {
        $repositorio = $request->getDataSet()->getRows()[0];
        $repositorioId = !empty($repositorio["ID"]) ? $repositorio["ID"] : null;
        $repositorioOperId = !empty($repositorio["D_ID"]) ? $repositorio["D_ID"] : null;

        try {
            ServiceInstance::getRepositorio()->removeRepositorio($repositorioId, $repositorioOperId);
        } catch(CustomException $e) {
            $response->setError(Utilities::getErrorObjectFromException($e));
        }
    }
}

